/* Generated by Together */

package com.cisco.netconf;
import com.cisco.netconf.rpc.RPCReply;

public interface BaseOperations extends Operations {
    /*
    * The config parameter is shown here as configScope, as it is scoping the
    * application of this operation. The format parameter has been added as
    * it is implied by the description.
    */
    public RPCReply getConfig(final String source,
        final Configuration configScope,
        final Format format );

    /*
    * The operation attribute is shown here as a parameter. operation,
    * testOption and errorOption should be enums.
	* The format parameter has been added as it is implied by the description.
    */
    public RPCReply editConfig(final EditOperation operation,
        final String target,
        final String testOption,
        final String errorOption,
        final Configuration configScope,
        final Format format);

    /*
    * Since an argument can only be one of type, the source is split into
    * two arguments, one of which is required. The format is described as
    * ideally omitted for this operation, but this is the only operation for
    * which it is explicitly specified.
    */
    public RPCReply copyConfig(final String sourceName,
        final Configuration sourceConfig,
        final String target,
        final Format format);

    public RPCReply deleteConfig(final String target);

    public RPCReply lock(final String target);

    public RPCReply unlock(final String target);

    /*
    * The state parameter is shown as a Configuration scope here to be
    * consistent with the other uses of the same idea. The description
    * indicates that this parameter could be text, but this is probably
    * a confusion with the format parameter.
    */
    public RPCReply getAll(final Configuration configScope,
        	final Format format);

    public RPCReply killSession(int sessionId);
}
