/* Generated by Together */

package com.cisco.netconf;

import com.cisco.netconf.rpc.RPCReply;
import java.net.URL;

public interface URLOperations extends Operations {
    /*
    * The operation attribute is shown here as a parameter. operation,
    * testOption and errorOption should be enums.
	* The format parameter has been added as it is implied by the description.
    */

    public RPCReply editConfig(final String operation,
        final String target,
        final String testOption,
        final String errorOption,
        final URL configScope,
        final Format format);

    /*
    * Since an argument can only be one of type, the source is split into
    * two arguments, one of which is required. The format is described as
    * ideally omitted for this operation, but this is the only operation for
    * which it is explicitly specified.
    */

    public RPCReply copyConfig(final URL source,
        final URL target,
        final Format format);

    /*
    * It is not clear here whether the configuration that is being
    * validated is one that has been already sent to the device, or
    * whether a configuration can be passed for validation. This
    * signature indicates that it is a configuration that has been
    * sent to the device already.
    */

    public RPCReply validate(final URL source);

    public RPCReply deleteConfig(final URL target);
}
